/*****************************************************************************
*
* Atmel Corporation
*
* ̧			: main.c
* ߲		: IAR EWAAVR 2.28a/3.10c
* 			: $Revision: 1.3 $
* t			: $Date: 17. mars 2004 14:47:06 $
* XV		: $Author: ltwa $
*
* xEҰ		: avr@atmel.com
*
* x޲	: SPIUSARTS޲gp\
*				  ATmega8pɏĂ܂B
*
* pLq		: AVR303 - SPI-UART
*
// 			: Andy Gayne. avr@gayne.co.uk   www.gd-technik.com
// 		: STK500ŊJAgp\
// 			:
// ۸тATmega8̎呕uSPI߰ĂRS232 ASCII[(Ⴆ߿ݏœ[
// ۸)Ԃ̌񋟂܂BĒ[߰Ă̌`ԐݒSPIoRް
// MɎgp邱ƂłASPI]uɑ΂ޯނƑݒʐM\ɂ
// B
****************************************************************************/

#include "allheaders.h"

// `
const char __flash crlf[] = "\r\n";
const char __flash backspace[] = "\b \b";
const char __flash exchange[] = " sent,  received=";
const char __flash prompt[] = "\r\n[H]-help >";
const char __flash nullprompt[] = "\r\n          ";
const char __flash error1[] = " [illegal character entered]\007";
const char __flash newstat[] = " New";
const char __flash bit0[] = " (MSB first)";
const char __flash bit1[] = " (LSB first)";
const char __flash auto0[] = " (pulse low)";
const char __flash auto1[] = " (pulse high)";
const char __flash auto2[] = " (off)";
const char __flash gap[] = "   ";
const char __flash cfgwrite[] = " configuration saved";
const char __flash config[] = "Configuration loaded -";
const char __flash noconfig[] = "No configuration stored, defaults used\007";

const char __flash status[][MAXSTATSTRLEN] =
{ "Status: ",
  "SCK=",
  "SS=",
  "Auto=",
  "Bit Order=",
  "Mode="
};

const char __flash help[][MAXHELPSTRLEN] =
{ "\r\n\r\n",
  "****** SPI Gateway - USART to SPI Master Bridge ******\r\n",
  "****** V1.1   Andy Gayne 2004    GD Technik, UK ******\r\n\r\n",
  "Enter hex encoded byte to send via SPI, or commands:\r\n",
  "[?] - Show current status\r\n",
  "[X] - Extended hex sequence ( maximum 16 bytes )\r\n",
  "[Q] - SCK freq ( ----SPI2X=0-----    ----SPI2X=1----- )\r\n",
  "               ( 0=F/4   921.6kHz    4=F/2  1.8432MHz )\r\n",
  "               ( 1=F/16  230.4kHz    5=F/8   460.8kHz )\r\n",
  "               ( 2=F/64   57.6kHz    6=F/32  115.2kHz )\r\n",
  "               ( 3=F/128  28.8kHz    7=F/64   57.6kHz )\r\n",
  "[S] - Slave Select pin level (0=low, 1=high)\r\n",
  "[P] - Auto-toggle SS control (0=low, 1=high, 2=off)\r\n",
  "[T] - Bit Transmission Order (0=MSB first, 1=LSB first)\r\n",
  "[M] - SPI Clock Mode         (0 : 1 : 2 : 3)\r\n",
  "      Mode  Leading-Edge     Trailing-Edge   CPOL CPHA\r\n",
  "       0    Sample(Rising)   Setup (Falling)   0    0\r\n",
  "       1    Setup (Rising)   Sample(Falling)   0    1\r\n",
  "       2    Sample(Falling)  Setup (Rising)    1    0\r\n",
  "       3    Setup (Falling)  Sample(Rising)    1    1\r\n",
  "[W] - Write (save) configuration (auto loaded at reset)\r\n\r\n"
// 1234567890123456789012345678901234567890123456789012345678901234  64
};
const char __flash freq[][MAXFREQSTRLEN] =
{ "  (921.6kHz  Fosc/4 - 3.6864MHz xtal)",
  "  (230.4kHz  Fosc/16 - 3.6864MHz xtal)",
  "  (57.6kHz  Fosc/64 - 3.6864MHz xtal)",
  "  (28.8kHz  Fosc/128 - 3.6864MHz xtal)",
  "  (1.8432MHz  Fosc/2 - 3.6864MHz xtal)",
  "  (460.8kHz  Fosc/8 - 3.6864MHz xtal)",
  "  (115.2kHz  Fosc/32 - 3.6864MHz xtal)",
  "  (57.6kHz  Fosc/64 - 3.6864MHz xtal)"
};

// S̕ϐ
__eeprom __no_init unsigned char config1, config2, config3, checksum;

union
{
  unsigned char flags;
  struct
  {
    unsigned char ss_level :1,
                  ss_auto  :2,
                  unused   :5;
  };
};

//***************************************************************************
// ֐
//***************************************************************************
__C_task void main( void )
{
  char tmp;

  USART_Init( 11 );		// USART(2.6864MHzؽَ19200bps)
  SPI_MasterInit();		// SPI呕u
  sspinadjust(1);		// wǉpɊւĖ̂ȂJnlSS݂ݒ(=High)
  ss_auto = 2;			// NOFFݒ

  __enable_interrupt();	// S̊荞݋(UART荞݋)

  send_str(crlf);		// 󂯓үUARTM
  send_str(crlf);
  send_str(help[1]);
  send_str(help[2]);
  send_str(crlf);

  loadconfig();			// (݂Ă)ۑ`ԐݒSPIĐݒ

  for( ; ; )			// JԂ
  {
    send_str(prompt);		// ͏q()UARTM
    tmp = getnextchar();	// UARTMl擾(Ԃt)

    if (isxdigit(tmp)) spi_tx(tmp);	// 16i2ړ͌SPIM
    else switch (tmp)		// 16iȊOŁA
    {
      case 'H':				// ߕ\
        showhelp();
        break;
      case '?':				// ݂̏ԕ\
        showstatus(STATLIST);
        break;
      case 'X':				// 16i菇
        hexsequence();
        break;
      case 'Q':				// SPISCKgݒ
        setfreq();
        break;
      case 'S':				// /SSݒlݒ
        setsspin();
        break;
      case 'P':				// /SSݎNݒ
        setautomode();
        break;
      case 'T':				// ]ޯďݒ
        setorder();
        break;
      case 'M':				// SPIʐݒ
        setmode();
        break;
      case 'W':				// `ԐݒEEPROMۑ
        writeconfig();
        break;
      default:
        if(isgraph(tmp)) send_str(backspace);	// ŏ(BSM)
    }
  }
}

//***************************************************************************
// send_str - ׯ ؂USART֕񑗐M
//***************************************************************************
void send_str (const char __flash * str)
{
  while (*str)		// Iq($00)̒O܂ł̕UARTM
  {
    USART_Transmit(*str);
    str++;
  }
}

//***************************************************************************
// getnextchar - UARTMl擾A\\Ȃ瑗Ԃ
//***************************************************************************
char getnextchar(void)
{
  char tmp;
  
  tmp = USART_Receive();					// UARTMl擾
  tmp = toupper(tmp);						// ˑ啶ϊ
  if (isgraph(tmp)) USART_Transmit(tmp);	// 󔒈ȊO̕\\őԂ
  return(tmp); 
}

//***************************************************************************
// htoa - `$0F܂ł2il16iASCIIɕϊ
//***************************************************************************
char htoa (char ch)
{
  ch += 0x30;				// ASCII"0"ɕϊ
  if (ch > '9') ch += 7;	// "9"z"A"ɍĕϊ
  return ch;
}

//***************************************************************************
// spi_tx - 2UARTM1޲ĒlSPIoRMASPIMlʒm
//***************************************************************************
void spi_tx (char u_nib)	// ̊֐͍ŏ͕̓Ƃēn܂B
{
  char spi_ch;

  if (u_nib > 0x39) u_nib -= 7;				// "A"`"F"Ȃ"9"ɑ悤Ɉړ
  u_nib -= 0x30;							// 2il擾(ASCIIϊ)
  u_nib = u_nib << 4;						// قɊi[

  spi_ch = getnextchar();					// 2ڂUARTM
  if (isxdigit(spi_ch))						// L16iŁA
  {
    if (spi_ch > 0x39) spi_ch -= 7;			// "A"`"F"Ȃ"9"ɑ悤Ɉړ
    spi_ch -= 0x30;							// 2il擾(ASCIIϊ)
    spi_ch |= u_nib;						// قƌ

    spi_ch = SPI_MasterTransmit(spi_ch);   // SPI޲ē]()

    send_str(exchange);                    // SPIMUARTM
										// MSPI޲Ă̕
    u_nib = (spi_ch & 0xf0) >> 4;			// ق2ilƂĎ擾
    USART_Transmit( htoa(u_nib) );			// ّΉ16iUARTM
    USART_Transmit( htoa(spi_ch & 0x0F) );	// ّΉ16iUARTM
  }
  else send_str(error1);					// ͂łUARTM
}

//***************************************************************************
// showhelp - ߉ʂƌ݂̐ݒ\(UARTM)
//***************************************************************************
void showhelp(void)
{
  char ix;

	// ׯ ؂helpz̑SUARTM
  for(ix = 0;ix < (sizeof(help)/MAXHELPSTRLEN);ix++) send_str(help[ix]);

  showstatus(STATLONG);		// 1s̏ԕUARTM
}

//***************************************************************************
// showstatus - ݂SPI߰Đݒ\(UARTM)
//***************************************************************************
void showstatus(char displaymode)
{
  char tmp, ix=0;

  if(displaymode == STATLIST) USART_Transmit(' ');	// ߓȊOňʒuUARTM

  for(;;)	// 5ڏI܂ŌJԂ
  {
    send_str(status[ix]);		// ΉڕUARTM
    switch(ix++){
      case 1:					// ۂSPIg
        tmp = (SPCR & 0x03) | ((SPSR & 1) << 2);	// SPIxwޯĒl擾
        USART_Transmit(htoa(tmp));					// SPIxwޯĒlUARTM
        if(displaymode == STATLIST) send_str(freq[tmp]);	// ߓȊOőΉg񕶎UARTM
        break;
      case 2:					// ۂ/SSݏ
        USART_Transmit(htoa((PORT_SPI & (1<<P_SS)) >> P_SS));	// /SSݏԒlUARTM
        break;
      case 3:					// /SSN
        USART_Transmit(htoa(ss_auto));				// NUARTM
        if(displaymode == STATLIST)					// ߓȊOŁA
        {
          if(!ss_auto) send_str(auto0);				// 0LowUARTM
          else if(ss_auto == 1) send_str(auto1);	// 1HighUARTM
          else send_str(auto2);						// 2OFFUARTM
        }
        break;
      case 4:					// SPIޯď
        tmp = (SPCR & (1 << DORD)) >> DORD;						// ޯďޯĒl擾
        USART_Transmit(htoa(tmp));								// ޯďlUARTM
        if((displaymode == STATLIST) && !tmp) send_str(bit0);	// ߓȊOMSBsUARTM
        if((displaymode == STATLIST) && tmp) send_str(bit1);	// ߓȊOLSBsUARTM
        break;
      case 5:					// SPI
        USART_Transmit(htoa((SPCR & 0x0C) >> 2));		// SPIʒlUARTM
        return;											// {֐I
    }
    if(displaymode == STATLIST) send_str(nullprompt);	// ߓȊOŉsUARTM
    else send_str(gap);									// ߓŋ󔒖ߍUARTM
  }
}

//***************************************************************************
// hexsequence - ޲ĈꊇSPI]
//***************************************************************************
void hexsequence(void)
{
  char tx_str[MAXSEQ*2];	// ASCII͗pޯ̧
  char rx_str[MAXSEQ];		// SPIMpޯ̧
  char length;
  int ix;
  
  for (ix = 0;ix < MAXSEQ*2;ix++)			// 擾
  {
    if (!(ix % 2)) USART_Transmit(':');		// 2ɕqUARTM
    tx_str[ix] = getnextchar();				// UARTMޯ̧ۑ

    if (tx_str[ix] == '\r') break;			// "Enter"Ŏ
    if (!isxdigit(tx_str[ix]))				// 
    {
      send_str(error1);						// ͕UARTM
      return;								// {֐I
    }
    if (tx_str[ix] > '9') tx_str[ix] -= 7;	// "A"`"F"Ȃ"9"ɑ悤Ɉړ
    tx_str[ix] -= 0x30;						// 2ilɕϊ
  }
  length = ix/2;							// ް ޲Đ擾

	// NON̏ꍇ/SSُ݂̱Ԃۏ
  if(!ss_auto)     sspinadjust(1);			// /SSLowȂA/SS݂Highݒ
  if(ss_auto == 1) sspinadjust(0);			// /SSHighȂA/SS݂Lowݒ

	// ̎_ɉtx_str͉ق̒llength~2޲Ă܂݂܂B
	// ޲Ăւ̕ϊASPI]()AM޲ĕ\SPI]ŒZԂōŝ
	// ۏ؂邽߂ɓƗJԂōs܂B

  for (ix = 0;ix < length;ix++)				// ق̒l޲ĕϊ
    tx_str[ix] = (tx_str[ix*2] << 4) | tx_str[(ix*2)+1];	// ㉺ٍ

  if(ss_auto != 2) sspinadjust(ss_auto);	// NȂA/SS݊ݒ

  for (ix = 0;ix < length;ix++)				// ޯ̧lASPI]
    rx_str[ix] = SPI_MasterTransmit(tx_str[ix]);	// Ή޲SPI]()

	// NȂA/SSُ݂Ԃɐݒ
  if(!ss_auto)     sspinadjust(1);			// /SSLowȂA/SS݂Highݒ
  if(ss_auto == 1) sspinadjust(0);			// /SSHighȂA/SS݂Lowݒ

  for (ix = 0;ix < length;ix++)				// SPIMl\
  {
    send_str(nullprompt);
    USART_Transmit( htoa((tx_str[ix] & 0xf0) >> 4) );	// SPIMUARTM
    USART_Transmit( htoa(tx_str[ix] & 0x0F) );			// SPIMUARTM
    send_str(exchange);
    USART_Transmit( htoa((rx_str[ix] & 0xf0) >> 4) );	// SPIMUARTM
    USART_Transmit( htoa(rx_str[ix] & 0x0F) );			// SPIMUARTM
  }
}

//***************************************************************************
// setfreq - SPI SCKgݒ
//***************************************************************************
void setfreq(void)
{
  char tmp;

  tmp = getnextchar();	// UARTM擾
  tmp -= 0x30;			// 2ilɕϊ

  if (tmp < 8)				// LwlŁA(lL蓾Ȃ(啶ϊ)̂ŕȂ)
  {
    SPCR &= 0xFC;							// SPRޯ(SPR1,SPR0)
    SPCR |= tmp & 0x03;						// wSPRޯĐݒ(wԍ2ޯ)
    if(tmp & 0x04) SPSR |= (1 << SPI2X);	// 4`7SPI2XޯĐݒ(=1)
    else SPSR &= ~(1 << SPI2X);				// ȂΉ(=0)
    send_str(newstat);						// "New"UARTM
    showstatus(STATLIST);					// ݒԂUSARTM
  }
  else send_str(error1);	// ͕UARTM
}

//***************************************************************************
// setsspin - SPI߰Ă/SSݏԕύX
//***************************************************************************
void setsspin(void)
{
  char tmp;

  tmp = getnextchar();	// UARTM擾
  tmp -= 0x30;			// 2ilɕϊ
  
  if (tmp < 2)				// LwlŁA(lL蓾Ȃ(啶ϊ)̂ŕȂ)
  {
    sspinadjust(tmp);			// /SSݒlύX
    send_str(newstat);			// "New"UARTM
    showstatus(STATLIST);		// ݒԂUSARTM
  }
  else send_str(error1);	// ͕UARTM
}

//***************************************************************************
// sspinadjust - SPI߰Ă/SSݏԕύX
//***************************************************************************
void sspinadjust(char level)
{
  if(level) PORT_SPI |= (1 << P_SS);	// 1ȂA/SS݂Highݒ
  else PORT_SPI &= ~(1 << P_SS);		// 0ȂA/SS݂Lowݒ
  ss_level = level;						// w/SSݏԔԍۑ
}

//***************************************************************************
// setautomode - /SSݎNw
//***************************************************************************
void setautomode(void)
{
  char tmp;
  
  tmp = getnextchar();	// UARTM擾
  tmp -= 0x30;			// 2ilɕϊ
  
  if (tmp < 3)				// LwlŁA(lL蓾Ȃ(啶ϊ)̂ŕȂ)
  {
    ss_auto = tmp;				// w莩Nԍۑ
    send_str(newstat);			// "New"UARTM
    showstatus(STATLIST);		// ݒԂUSARTM
  }
  else send_str(error1);	// ͕UARTM
}

//***************************************************************************
// setorder - SPI]ޯďw
//***************************************************************************
void setorder(void)
{
  char tmp;
  
  tmp = getnextchar();	// UARTM擾
  tmp -= 0x30;			// 2ilɕϊ
  
  if (tmp < 2)				// LwlŁA(lL蓾Ȃ(啶ϊ)̂ŕȂ)
  {
    if(tmp) SPCR |= (1 << DORD);	// 1ȂADORDޯĐݒ(=1)
    else SPCR &= ~(1 << DORD);   	// 0ȂADORDޯĉ(=0)
    send_str(newstat);				// "New"UARTM
    showstatus(STATLIST);			// ݒԂUSARTM
  }
  else send_str(error1);	// ͕UARTM
}

//***************************************************************************
// setmode - SPIʎw
//***************************************************************************
void setmode(void)
{
  char tmp;
  
  tmp = getnextchar();	// UARTM擾
  tmp -= 0x30;			// 2ilɕϊ
  
  if (tmp < 4)				// LwlŁA(lL蓾Ȃ(啶ϊ)̂ŕȂ)
  {
    SPCR &= 0xF3;				// CPLCPHAޯ(ޯ3,2)
    SPCR |= tmp << 2;			// CPLCPHAޯĎwlݒ
    send_str(newstat);			// "New"UARTM
    showstatus(STATLIST);		// ݒԂUSARTM
  }
  else send_str(error1);	// ͕UARTM
}

//***************************************************************************
// writeconfig - ݂̌`ԐݒEEPROMɕۑ
//***************************************************************************
void writeconfig(void)
{
  __disable_interrupt(); 	// S̊荞݋֎~
  config1 = SPCR;			// SPIڼ޽(SPCR)lEEPROMۑ
  config2 = SPSR;			// SPIڼ޽(SPSR)lEEPROMۑ
  config3 = flags;			// S̕ϐEEPROMۑ
  checksum = 0 - (config1 + config2 + config3);		// EEPROMۑ
  __enable_interrupt();		// S̊荞݋(UART荞݋)
  send_str(cfgwrite);		// ݒۑUARTM
}

//***************************************************************************
// loadconfig - EEPROM`ԐݒōĐݒ
//***************************************************************************
void loadconfig(void)
{
  if (!((config1 + config2 + config3 + checksum) & 0xFF))	// шvŁA
  {
    SPCR = config1;			// SPIڼ޽(SPCR)l
    SPSR = config2;			// SPIڼ޽(SPSR)l
    flags = config3;		// S̕ϐ

    sspinadjust(ss_level);	// /SSݒlw܂͊lɉ

    send_str(config);		// `Ԏ擾/ݒ蕶UARTM
    showstatus(STATLIST);	// ݒԂUSARTM
  }
  else send_str(noconfig);	// ۑȂ/lUARTM
}
